/*
 * SPI_und_CAN.c
 *
 * Created: 16.08.2012 19:17:31
 *  Author: ls4446s
 */ 

#include <avr/io.h>
#define F_CPU 14318180UL
#define BAUD 19200UL
#include <util/delay.h>
#include <avr/interrupt.h>
#include <stdlib.h>
#define INT7_vect	_VECTOR(8)
#include "spi.h"
#include "mcp2515.h"
#include "usart_atmega128_steindorf.h"
CANMessage Nachricht; 
char buffer[10];

ISR (INT7_vect)
{
	USART1_puts("Daten empfangen\n");
	CAN_ReceiveMessage(&Nachricht);
	for (uint8_t i=0;i<Nachricht.length;i++)
	{
		itoa(i,buffer,10);
		USART1_puts("Daten[");
		USART1_puts(buffer);
		USART1_puts("]= 0b");
		itoa(Nachricht.data[i],buffer,2);
		USART1_puts(buffer);
		USART1_puts("\n");
	}
}

int main(void)
{
	char c;
	USART1_init(BAUD);	
	USART1_puts("MCU 1 USART1-Initialisierung erfolgreich\n");
	USART1_puts("	(1) LED an/aus schalten\n	(2) Nachricht senden\n");
	MCP2515_Init();
	
	
	// LED PIN Config (dient nur dazu, die controller voneinander unterscheiden
	// zu knnen
	DDRA|=1<<0;
	PORTA|=1<<0;
	
	sei();
	
    while(1)
    {
		c=USART1_getc();
        if (c==1)
        {
			if (!(PINA&(1<<0)))
				PORTA|=(1<<0); 
			else
				PORTA&=~(1<<0);
        }
		if (c==2)
		{
			Nachricht.id=0x123;
			Nachricht.rtr=0;
			Nachricht.length=2;
			Nachricht.data[0]=0b1010;
			Nachricht.data[1]=0b1100;
			uint8_t ret=CAN_SendMessage(&Nachricht);
			switch (ret)
			{
				case 0: USART1_puts("Nachricht gesendet mit TXB0\n");break;
				case 1: USART1_puts("Nachricht gesendet mit TXB1\n");break;
				case 2: USART1_puts("Nachricht gesendet mit TXB2\n");break;
				case 255: USART1_puts("Fehler bei der bertragung\n");
			}
			USART1_puts("back to while(1)\n");
		}
    }
}