/*
 * spi.h
 *
 * Created: 16.08.2012 19:19:13
 * Author: ls4446s
 */ 


#ifndef SPI_H_
#define SPI_H_

#define DDR_SPI		DDRB
#define PORT_SPI	PORTB
#define SPI_SS		DDB0
#define SPI_MOSI	DDB2
#define SPI_SCK		DDB1
#define SPI_MISO	DDB3

#define SS_Output()		DDR_SPI|=(1<<SPI_SS);
#define SS_High()		PORT_SPI|=(1<<SPI_SS);
#define SS_Low()		PORT_SPI&=~(1<<SPI_SS);

// BIT configuration
#define SPE			6
#define MSTR		4
#define SPR0		0
#define SPR1		1
#define SPI2X		0
#define SPIE		7
#define SPIF		7



// SPI communication controlled by interrupts
void SPI_MasterInit()
{
	uint8_t clear;
	DDR_SPI|=(1<<SPI_MOSI)|(1<<SPI_SCK);
	
	SPCR = (1<<SPE)|(1<<MSTR)|(1<<SPIE);
	SPSR = (1<<SPI2X);
	
	clear=SPSR;
	clear=SPDR;
	
	SS_Output();
	SS_High();
	
}

uint8_t SPI_MasterTransmitAndReceive(uint8_t data)
{
	SPDR=data;
	while (!(SPSR&(1<<SPIF)))
		;
	
	return SPDR;
}



#endif /* SPI_H_ */